#ifndef _CONTEXTUAL_NEURAL_NETWORK_H
#define _CONTEXTUAL_NEURAL_NETWORK_H 1

#include<iostream>
#include<vector>
#include<cmath>
#include"rand.h"
#include<cfloat>
#include<map>

#include"network.h"

using namespace std;

struct GNN:public NN_SoftMaxOutput, public NN_tanhAct{
	typedef enum {Unset,BackpropT,FreqBackpropT,RelL2MetricT,BPMetricT,UnitOutProdT} TauGradType;
	TauGradType tauGradType;
	vector<vector<long double> > tau,taugrad,prev_tau; //tau[x][e]  transition weight for edge e upon reading symbol x
	vector<vector<long double> > taubias,taubiasgrad,prev_taubias; //taubias[x][i]  bias for unit i upon reading symbol x  = transition weight from always-activated unit
	vector<long double> start,prev_start,startgrad; //start[i] = value of V[i] at time 0
	vector<vector<long double> > B;  // B[t][i] backpropagated value at unit i at time t (wrt V)
	vector<vector<long double> > metricV; // metricV[t][i] metric for activity of unit i at time t, eg backpropagated metric or empirical nat grad
	vector<long double> aux; //auxiliary variable to help computations
	virtual int suggestedConn();
	virtual void Setup(long maxDatumLength);
	virtual void saveTauParams();virtual void restoreTauParams();
	virtual void setToStartAct();
	virtual void computeNextAct(long t,long symbol_read);
	virtual void initWeights();
	virtual void computeTauGrad(const vector<long>& datum);
	virtual void applyTauGrad(long double rate);
	virtual void computeBackprop(const vector<long>& datum);
	virtual void computeTauDiff(const vector<long>& datum);
	virtual void computeMetricInverse(const vector<long>& datum);
	virtual void computeRelativeL2Metric(const vector<long>& datum);
	virtual void computeBPM(const vector<long>& datum);
	virtual void computeUnitOutProdMetric(const vector<long>& datum);
};

#endif
