#include<iostream>
#include<vector>
#include<cmath>
#include"rand.h"
#include<cfloat>
#include<map>

#include "network.h"

using namespace std;

struct HMM:public PredictorNetwork{
	virtual int suggestedConn();// suggestion of connectivity to balance out various terms in the algorithmic cost of training. Needs to have other parameters already set

	vector<vector<long double> > act;  //act[t][i] is the activity of unit i at time t
	vector<vector<long double> > w,prev_w;  //w[x][i] writing weight for symbol x at unit i
	vector<long double> tau,prev_tau; // tau[e]=transition rate for edge e
	vector<long double> start,prev_start; //start[i] = starting distribution = value of act[0][i]
	vector<vector<long double> > B;  // B[t][i] backpropagated value at unit i at time t
	vector<long double> aux; //auxiliary variable to help computations
	vector<vector<long double> > waux; //auxiliary variable to help computations
	vector<long double> tauaux; //auxiliary variable to help computations
	vector<long double> gain; //normalization constants

	virtual void Setup(long maxdatalength); //builds the arrays to store values
	virtual void initWeights();
	virtual void setToStartAct();
	virtual void computeNextAct(long t,long symbol_read);//fills act[t] given act[t-1] and last symbol read
	virtual void computePred(long t);//fills pred[t][x] from act[t]
	virtual long double computePred(long t,long x);//returns pred[t][x] from act[t] (useful in case pred[t][x] can be computed for each x individually)
	virtual void saveWParams();virtual void restoreWParams();
	virtual void saveTauParams();virtual void restoreTauParams();
	virtual void computeBack(const vector<long>&datum);//fills B[t][i]
	virtual void applyEM(const vector<long>& datum);
};


