#include"lstm.h"

void LSTM::computeNextAct(long t,long x)//used with t>=1 and x the latest input read
{
 int i,j,e;
 //This code is not really optimized...
 //Input gate
 for(j=0;j<n;j++)
	 Vinput[t][j]=readinput[x][j]+biasinput[j]+wcinput[j]*actcell[t-1][j];
 for(e=0;e<nedges;e++)
	 Vinput[t][edgedest[e]]+=tauinput[e]*act[t-1][edgesrc[e]];
 for(i=0;i<n;i++)actinput[t][i]=f(Vinput[t][i]);
 //Forget gate
 for(j=0;j<n;j++)
	 Vforget[t][j]=readforget[x][j]+biasforget[j]+wcforget[j]*actcell[t-1][j];
 for(e=0;e<nedges;e++)
	 Vforget[t][edgedest[e]]+=tauforget[e]*act[t-1][edgesrc[e]];
 for(i=0;i<n;i++)actforget[t][i]=f(Vforget[t][i]);
 //Main cell
 for(j=0;j<n;j++)
	 V[t][j]=read[x][j]+bias[j];
 for(e=0;e<nedges;e++)
	 V[t][edgedest[e]]+=tau[e]*act[t-1][edgesrc[e]];
 for(j=0;j<n;j++)
	 actcell[t][j]=actforget[t][j]*actcell[t-1][j]+actinput[t][j]*g(V[t][j]);
 //Output gate
 for(j=0;j<n;j++)
	 Voutput[t][j]=readoutput[x][j]+biasoutput[j]+wcoutput[j]*actcell[t][j];//This is actcell[t] not actcell[t-1]
 for(e=0;e<nedges;e++)
	 Voutput[t][edgedest[e]]+=tauoutput[e]*act[t-1][edgesrc[e]];
 for(i=0;i<n;i++)actoutput[t][i]=f(Voutput[t][i]);
 //Cell output
 for(i=0;i<n;i++)act[t][i]=actoutput[t][i]*h(actcell[t][i]);
}

void LSTM::computeBackprop(const vector<long>& datum)
{
 int t,i,e;long x,y;
 for(i=0;i<n;i++)B[datum.size()][i]=0;
 for(i=0;i<n;i++)Binput[datum.size()][i]=0;
 for(i=0;i<n;i++)Bforget[datum.size()][i]=0;
 for(i=0;i<n;i++)Boutput[datum.size()][i]=0;
 for(i=0;i<n;i++)Bcell[datum.size()][i]=0;
 for(t=datum.size()-1;t>=0;t--){
	 x=datum[t];
	 //Compute derivative wrt act[t][i] and put it into B[t][i]
	 //Contribution to network output
	 if(isToPredict(datum,t)){
		 for(i=0;i<n;i++)B[t][i]=w[x][i];
		 for(y=0;y<alph;y++)for(i=0;i<n;i++)
			 B[t][i]-=pred[t][y]*w[y][i];
	 }else{
		 for(i=0;i<n;i++)B[t][i]=0;
	 }
	 //contribution to next actcell
	 for(e=0;e<nedges;e++)
		 B[t][edgesrc[e]]+=tauinput[e]*Binput[t+1][edgedest[e]]+
			 tauforget[e]*Bforget[t+1][edgedest[e]]+
			 tau[e]*B[t+1][edgedest[e]]+
			 tauoutput[e]*Boutput[t+1][edgedest[e]];
	 //compute derivative wrt Voutput[t][i]
	 for(i=0;i<n;i++){
		 Boutput[t][i]=B[t][i]*h(actcell[t][i]);
		 Boutput[t][i]*=derf(Voutput[t][i]);
	 }
	 //compute derivative wrt actcell[t][i]
	 for(i=0;i<n;i++)
		 Bcell[t][i]=B[t][i]*actoutput[t][i]*derh(actcell[t][i])+
			 actforget[t+1][i]*Bcell[t+1][i]+
			 wcinput[i]*Binput[t+1][i]+
			 wcforget[i]*Bforget[t+1][i]+
			 wcoutput[i]*Boutput[t][i];//this is t not t+1
	 //turn B[t][i] into derivative wrt V[t][i]
	 for(i=0;i<n;i++)B[t][i]=actinput[t][i]*derg(V[t][i])*Bcell[t][i];
	 //compute derivative wrt Vforget[t][i]
	 if(t>0){
		 for(i=0;i<n;i++)
			 Bforget[t][i]=Bcell[t][i]*actcell[t-1][i]*derf(Vforget[t][i]);
	 }else{
		 for(i=0;i<n;i++)Bforget[t][i]=0;
	 }
	 //compute derivative wrt Vinput[t][i]
	 for(i=0;i<n;i++)
		 Binput[t][i]=Bcell[t][i]*g(V[t][i])*derf(Vinput[t][i]);
 }
}

void LSTM::Setup(long maxDatumLength)
{
 RNN::Setup(maxDatumLength);
 actinput=actforget=actoutput=actcell=act;
 Vinput=Vforget=Voutput=V;
 Binput=Bforget=Boutput=Bcell=B;
 tauinput=tauforget=tauoutput=tauinputgrad=tauforgetgrad=tauoutputgrad=tau;
 readinput=readforget=readoutput=readinputgrad=readforgetgrad=readoutputgrad=read;
 biasinput=biasforget=biasoutput=biasinputgrad=biasforgetgrad=biasoutputgrad=bias;
 wcinput=wcforget=wcoutput=wcinputgrad=wcforgetgrad=wcoutputgrad=vector<long double>(n,0.);
}

void LSTM::saveTauParams()
{
 prev_tau=tau;prev_bias=bias;/*prev_start=start;*/prev_read=read;
 prev_tauinput=tauinput;prev_biasinput=biasinput;prev_readinput=readinput;prev_wcinput=wcinput;
 prev_tauforget=tauforget;prev_biasforget=biasforget;prev_readforget=readforget;prev_wcforget=wcforget;
 prev_tauoutput=tauoutput;prev_biasoutput=biasoutput;prev_readoutput=readoutput;prev_wcoutput=wcoutput;
}

void LSTM::restoreTauParams()
{
 tau=prev_tau;bias=prev_bias;/*start=prev_start;*/read=prev_read;
 tauinput=prev_tauinput;biasinput=prev_biasinput;readinput=prev_readinput;wcinput=prev_wcinput;
 tauforget=prev_tauforget;biasforget=prev_biasforget;readforget=prev_readforget;wcforget=prev_wcforget;
 tauoutput=prev_tauoutput;biasoutput=prev_biasoutput;readoutput=prev_readoutput;wcoutput=prev_wcoutput;
}

//to optimize, should define the derivatives using act as the argument...
long double LSTM::f(long double v){return 1./(1.+expl(-v));}
long double LSTM::derf(long double v){long double a=f(v);return a*(1.-a);}
long double LSTM::g(long double v){return tanhl(v);}
long double LSTM::derg(long double v){long double a=tanhl(v);return 1.-a*a;}
long double LSTM::h(long double v){return tanhl(v);}
long double LSTM::derh(long double v){long double a=tanhl(v);return 1.-a*a;}

void LSTM::setToStartAct()
{
 int i,j;long t=0;
 //Set all matrices to 0, still apply activation functions
 for(j=0;j<n;j++)Vinput[t][j]=0;
 for(i=0;i<n;i++)actinput[t][i]=f(Vinput[t][i]);
 for(j=0;j<n;j++)Vforget[t][j]=0;
 for(i=0;i<n;i++)actforget[t][i]=f(Vforget[t][i]);
 for(j=0;j<n;j++)V[t][j]=0;
 for(j=0;j<n;j++)actcell[t][j]=actinput[t][j]*g(V[t][j]);
 for(j=0;j<n;j++)Voutput[t][j]=0;
 for(i=0;i<n;i++)actoutput[t][i]=f(Voutput[t][i]);
 for(i=0;i<n;i++)act[t][i]=actoutput[t][i]*h(actcell[t][i]);
}

void LSTM::initWeights()
{
 long i,e,y;long double init=.1;//All params are uniform in [-init;init]
 //Put the right global frequencies
 for(y=0;y<alph;y++)wbias[y]=logl(predfreq[y]);
 for(e=0;e<nedges;e++){
	 tau[e]=2*init*alea()-init;
	 tauinput[e]=2*init*alea()-init;
	 tauforget[e]=2*init*alea()-init;
	 tauoutput[e]=2*init*alea()-init;
 }
 for(i=0;i<n;i++){
	 for(y=0;y<alph;y++)w[y][i]=2*init*alea()-init;
	 bias[i]=2*init*alea()-init;
	 biasinput[i]=2*init*alea()-init;
	 biasforget[i]=2*init*alea()-init;
	 biasoutput[i]=2*init*alea()-init;
	 wcinput[i]=2*init*alea()-init;
	 wcforget[i]=2*init*alea()-init;
	 wcoutput[i]=2*init*alea()-init;
	 for(long y=0;y<alph;y++){
		 read[y][i]=2*init*alea()-init;
		 readinput[y][i]=2*init*alea()-init;
		 readforget[y][i]=2*init*alea()-init;
		 readoutput[y][i]=2*init*alea()-init;
	 }
 }
}

void LSTM::computeTauDiff(const vector<long>& datum)
{
 computeBackprop(datum);
 unsigned long t;
 int j,e;long x,y;

 for(e=0;e<nedges;e++){
	 taugrad[e]=0;tauinputgrad[e]=0;tauforgetgrad[e]=0;tauoutputgrad[e]=0;
 }
 for(j=0;j<n;j++){
	 biasgrad[j]=0;biasinputgrad[j]=0;biasforgetgrad[j]=0;biasoutputgrad[j]=0;
	 wcinputgrad[j]=0;wcforgetgrad[j]=0;wcoutputgrad[j]=0;
 }
 for(y=0;y<alph;y++)for(j=0;j<n;j++){
	 readgrad[y][j]=0;readinputgrad[y][j]=0;readforgetgrad[y][j]=0;readoutputgrad[y][j]=0;
 }

 for(t=0;t<datum.size()-1;t++){
	 x=datum[t];
	 for(e=0;e<nedges;e++){
		 taugrad[e]+=act[t][edgesrc[e]]*B[t+1][edgedest[e]];
		 tauinputgrad[e]+=act[t][edgesrc[e]]*Binput[t+1][edgedest[e]];
		 tauforgetgrad[e]+=act[t][edgesrc[e]]*Bforget[t+1][edgedest[e]];
		 tauoutputgrad[e]+=act[t][edgesrc[e]]*Boutput[t+1][edgedest[e]];
	 }
	 for(j=0;j<n;j++){
		 biasgrad[j]+=B[t+1][j];
		 biasinputgrad[j]+=Binput[t+1][j];
		 biasforgetgrad[j]+=Bforget[t+1][j];
		 biasoutputgrad[j]+=Boutput[t+1][j];
	 }
	 for(j=0;j<n;j++){
		 readgrad[x][j]+=B[t+1][j];
		 readinputgrad[x][j]+=Binput[t+1][j];
		 readforgetgrad[x][j]+=Bforget[t+1][j];
		 readoutputgrad[x][j]+=Boutput[t+1][j];
	 }
	 for(j=0;j<n;j++){
		 wcinputgrad[j]+=actcell[t][j]*Binput[t+1][j];
		 wcforgetgrad[j]+=actcell[t][j]*Bforget[t+1][j];
		 wcoutputgrad[j]+=actcell[t+1][j]*Boutput[t+1][j];//this is t+1 not t
	 }
 }
//According to Graves, no need to learn the initial state at t=0
}

void LSTM::computeTauGrad(const vector<long>& datum)
{
 computeTauDiff(datum);
 int j,e;long y;

 long double normalize=1.l/datum.size();

 switch(tauGradType){
	 case Unset:cerr<<"Gradient type for transition parameters is not set!"<<endl;break;

	 case BackpropT:
							for(e=0;e<nedges;e++)taugrad[e]*=normalize;
							for(j=0;j<n;j++)biasgrad[j]*=normalize;
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readgrad[y][j]*=normalize;
							for(e=0;e<nedges;e++)tauinputgrad[e]*=normalize;
							for(j=0;j<n;j++)biasinputgrad[j]*=normalize;
							for(j=0;j<n;j++)wcinputgrad[j]*=normalize;
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readinputgrad[y][j]*=normalize;
							for(e=0;e<nedges;e++)tauforgetgrad[e]*=normalize;
							for(j=0;j<n;j++)biasforgetgrad[j]*=normalize;
							for(j=0;j<n;j++)wcforgetgrad[j]*=normalize;
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readforgetgrad[y][j]*=normalize;
							for(e=0;e<nedges;e++)tauoutputgrad[e]*=normalize;
							for(j=0;j<n;j++)biasoutputgrad[j]*=normalize;
							for(j=0;j<n;j++)wcoutputgrad[j]*=normalize;
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readoutputgrad[y][j]*=normalize;
							break;

	 case FreqBackpropT:
							for(e=0;e<nedges;e++)taugrad[e]/=datum.size();
							for(j=0;j<n;j++)biasgrad[j]/=datum.size();
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readgrad[y][j]/=(datum.size()*readfreq[y]);
							for(e=0;e<nedges;e++)tauinputgrad[e]/=datum.size();
							for(j=0;j<n;j++)biasinputgrad[j]/=datum.size();
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readinputgrad[y][j]/=(datum.size()*readfreq[y]);
							for(j=0;j<n;j++)wcinputgrad[j]/=datum.size();
							for(e=0;e<nedges;e++)tauforgetgrad[e]/=datum.size();
							for(j=0;j<n;j++)biasforgetgrad[j]/=datum.size();
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readforgetgrad[y][j]/=(datum.size()*readfreq[y]);
							for(j=0;j<n;j++)wcforgetgrad[j]/=datum.size();
							for(e=0;e<nedges;e++)tauoutputgrad[e]/=datum.size();
							for(j=0;j<n;j++)biasoutputgrad[j]/=datum.size();
							for(y=0;y<alph;y++)for(j=0;j<n;j++)readoutputgrad[y][j]/=(datum.size()*readfreq[y]);
							for(j=0;j<n;j++)wcoutputgrad[j]/=datum.size();
							break;

	 case QDOutProdT:case QDBPMetricT:case RootMeanSquareT:
							cerr<<"This gradient is not yet implemented for LSTMs. Would be worth a try though."<<endl;
							break;

 }
}

void LSTM::applyTauGrad(long double rate)
{
 int e,i;long y;
 for(e=0;e<nedges;e++){
	 tau[e]+=rate*taugrad[e];
	 tauinput[e]+=rate*tauinputgrad[e];
	 tauforget[e]+=rate*tauforgetgrad[e];
	 tauoutput[e]+=rate*tauoutputgrad[e];
 }
 for(i=0;i<n;i++){
	 bias[i]+=rate*biasgrad[i];
	 biasinput[i]+=rate*biasinputgrad[i];wcinput[i]+=rate*wcinputgrad[i];
	 biasforget[i]+=rate*biasforgetgrad[i];wcforget[i]+=rate*wcforgetgrad[i];
	 biasoutput[i]+=rate*biasoutputgrad[i];wcoutput[i]+=rate*wcoutputgrad[i];
 }
 for(y=0;y<alph;y++)for(i=0;i<n;i++){
	 read[y][i]+=rate*readgrad[y][i];
	 readinput[y][i]+=rate*readinputgrad[y][i];
	 readforget[y][i]+=rate*readforgetgrad[y][i];
	 readoutput[y][i]+=rate*readinputgrad[y][i];
 }

}

