#set terminal svg enhanced size 450 300
set terminal post eps enhanced size 5, 3
set samples 1001  # high quality
set border 15 linewidth .3 # thin border
set output "anbn_all.eps"
set linestyle  1 pt 7 ps .55 lc rgb "blue"
set linestyle  4 pt 1 ps .8 lc rgb "green"
set linestyle  6 pt 1 ps .8 lc rgb "cyan"
set linestyle  5 pt 1 ps .8 lc rgb "orange"
set linestyle  2 pt 1 ps .8 lc rgb "red"
set ylabel "Validation log-likelihood (bits)"
set xlabel "Computation time (seconds)"
set xrange [0:600]
set yrange [-350:-30]
plot -100 with lines title "True model entropy" linestyle 3 lw 4 \
, -243.5 with lines title "Sanity check (CTW)" linestyle 0 lw 5 \
,"anbn_rnn_dh_fb_4_3" using 2:4 title "RNN BP" linestyle 1 with lines \
,"anbn_rnn_dh_fb_6_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_8_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_11_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_16_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_23_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_32_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_45_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_64_3" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_4_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_6_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_8_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_11_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_16_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_23_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_32_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_45_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_rnn_dh_fb_64_0" using 2:4 title "" linestyle 1 with lines \
,"anbn_glnn_qdh_uop_4_3" using 2:4 title "GLNN RUOP" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_6_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_8_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_11_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_16_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_23_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_32_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_45_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_64_3" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_4_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_6_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_8_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_11_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_16_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_23_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_32_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_45_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_uop_64_0" using 2:4 title "" linestyle 5 with lines \
,"anbn_glnn_qdh_bpm_4_3" using 2:4 title "GLNN RBPM" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_6_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_8_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_11_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_16_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_23_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_32_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_45_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_64_3" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_4_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_6_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_8_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_11_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_16_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_23_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_32_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_45_0" using 2:4 title "" linestyle 2 with lines \
,"anbn_glnn_qdh_bpm_64_0" using 2:4 title "" linestyle 2 with lines
;
# ,"anbn_rnn_qdh_qduop_4_3" using 2:4 title "RNN QDUOP" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_6_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_8_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_11_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_16_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_23_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_32_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_45_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_64_3" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_4_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_6_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_8_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_11_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_16_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_23_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_32_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_45_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qduop_64_0" using 2:4 title "" linestyle 6 with lines \
# ,"anbn_rnn_qdh_qdbpm_4_3" using 2:4 title "RNN QDBPM" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_6_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_8_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_11_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_16_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_23_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_32_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_45_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_64_3" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_4_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_6_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_8_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_11_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_16_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_23_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_32_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_45_0" using 2:4 title "" linestyle 4 with lines \
# ,"anbn_rnn_qdh_qdbpm_64_0" using 2:4 title "" linestyle 4 with lines \
