#set terminal svg enhanced size 450 300
set terminal post eps enhanced size 5, 3
set samples 1001  # high quality
set border 15 linewidth .3 # thin border
set output "xor_all.eps"
set linestyle  1 pt 7 ps .55 lc rgb "blue"
set linestyle  2 pt 1 ps .8 lc rgb "red"
set ylabel "Validation log-likelihood (bits)"
set y2label "Classification error (%)"
#set xlabel "Gradient passes"
set xlabel "Computation time (minutes)"
#set xrange [0:1500]
set xrange [0:800]
set yrange [-11000:2000]
set y2range [-5:60]
set ytics auto nomirror
set y2tics auto nomirror

plot 0 with lines title "" linestyle 3 lw 4 \
,"xor_glnn_qdh_bpm_xor_10_10_1" using ($2/60):4 title "log-likelihood" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_2" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_3" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_4" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_5" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_6" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_7" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_8" using ($2/60):4 title "" linestyle 1 with lines \
,"xor_glnn_qdh_bpm_xor_10_10_1" using ($2/60):($6/100) title "classification error" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_2" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_3" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_4" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_5" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_6" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_7" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
,"xor_glnn_qdh_bpm_xor_10_10_8" using ($2/60):($6/100) title "" linestyle 2 with lines axes x1y2 \
;
